import React, {useRef, useState} from 'react';
import {connect} from 'react-redux';
import {NavLink, useHistory} from 'react-router-dom';
import {actionLogin} from '../../Actions/action_login';
import LoginError from '../../Components/LoginError/LoginError';
import './Login.css';
import Button from "../../Components/Button/Button";

const Login = ({onLogin = null, checkLogin = false, promiseLoginStatus, payloadLogin, loginNetworkError}) => {    //деструктуризация объекта

    const history = useHistory();

    if (checkLogin) {
        history.push('/profile')
    }

    if (localStorage.authToken) {
        history.push('/profile')
    }

    if (loginNetworkError) {
        history.push('/404')
    }

    const loginRef = useRef(null)
    const pasRef = useRef(null)

    const [login, setLogin] = useState('')
    const [password, setPassword] = useState('')

    const isLoginValid = () => {
        if (!login || !password) return false
        else return true
    }

    const RESOLVED = 'RESOLVED'

    return (
        <>
            <div className='login-wrapper'>
                <input
                    value={login}
                    placeholder='Login'
                    ref={loginRef}
                    onChange={(e) => setLogin(e.target.value)}
                />

                <input
                    value={password}
                    placeholder='Password'
                    ref={pasRef} onChange={(e) => setPassword(e.target.value)}
                    type='password'
                />

                <Button
                    name='Login'
                    isValid={isLoginValid()}
                    callback={() => onLogin(login, password)}
                />

                <nav className='login-wrapper__link'>
                    <NavLink to='/registration'>Registration</NavLink>
                </nav>

                {promiseLoginStatus === RESOLVED && payloadLogin === null && <LoginError/>}
            </div>

            {/*/!*{(pending1 || pending2) && gif}*!/ for registration*/}

        </>
    )
}

const CLogin = connect((state) => ({
    checkLogin: state.auth.isLogin,
    promiseLoginStatus: state?.promise?.Login?.status,
    payloadLogin: state?.promise?.Login?.payload?.data?.login,
    loginNetworkError: state?.errors?.loginNetworkError
}), {onLogin: actionLogin})(Login)

export default CLogin;