const LOGINNETWORKERROR = 'LOGINNETWORKERROR';
const LOGINNETWORKERRORRESET = 'LOGINNETWORKERRORRESET';
const LOGIN = 'LOGIN';
const LOGOUT = 'LOGOUT';
const USERERROR = 'USERERROR';
const USERERRORRESET = 'USERERRORRESET';

export const actionLoginNetworkError = () => {
    return {
        type: LOGINNETWORKERROR
    }
}

export const actionLoginNetworkErrorReset = () => {
    return {
        type: LOGINNETWORKERRORRESET
    }
}

export const actionUserError = () => {
    return {
        type: USERERROR
    }
}

export const actionUserErrorReset = () => {
    return {
        type: USERERRORRESET
    }
}

export const errorReducer = (state, action) => {
    if(!state) {
        return {
            loginNetworkError: false,
            existingUserError: false
        }
    }
    
    switch(action.type) {
        case LOGINNETWORKERROR: 
            return {
                ...state,
                loginNetworkError: true
            }
        case LOGINNETWORKERRORRESET: 
            return {
                ...state,
                loginNetworkError: false
            }
        case LOGIN:
            return {};
        case LOGOUT:
            return {};
        case USERERROR:
            return {
                ...state,
                existingUserError: true
            };
        case USERERRORRESET:
            return {
                ...state,
                existingUserError: false
            };
        default:
            return state
    }
}